% Number of discretisation steps
 N=100;

% Number of Newton iterations
nNewton=3;

% End point
T=1;

% Step size
h=T/N;

% Algebraic condition function handle
c= @(y) ...
% Derivative of the algebraic condition
dc = @(y) ...

% Right hand side function and its derivative
f = @(y) [...];
df = @(y) [...];

% Initial value
y = ...
% Coefficients of the RK method
A = ...
b = ...

% Initialise the distance from the manifold
ZB = zeros(N+1,1);
ZB(1) = c(y);

% Allocation of variables for the components of the solution
X = zeros(5, N+1);
X(:, 1) = y;

for ii=1:N
    
    % Computing the approximate solution via Newton iterations
    X(:, ii+1) = ...;
    
    % Computing the distance from the manifold
    ZB(ii+1) = ...;
end

fprintf('Maximal distance from the manifold: %e\n', max(abs(ZB)));

% Plot of the algebraic conditions evolution (i.e. distance from the
% manifold) 
t=0:h:N*h;
figure;
plot(0:h:N*h, ZB, '*-');
print -dpdf ErrorManifold
% Plot of the component evolution
figure;
plot(t, X(1, :), '*-', t, X(2, :), '*-', t, X(3, :), '*-',t, X(4, :),...
    '*-', t, X(5, :), '*-');
hold on;

% Computing the reference solution via ode23t
f = @(t,y) [y(1)*y(2)*y(3);...
            y(5)*y(3)+y(2);...
            -cos(y(1))*y(4)+pi;...
            -y(2)+y(4);...
            y(1)^2+3*y(3)^2-4*y(5)+y(2)*y(4)^3];
J = @(t,y) [y(2)*y(3) y(1)*y(3) y(1)*y(2) 0 0;...
            0 1 y(5) 0 y(3);...
            -sin(y(1))*y(4) 0 0 -cos(y(1)) 0;...
            0 -1 0 1 0;...
            2*y(1) y(4)^3 6*y(3) 3*y(2)*y(4)^2 -4];
M = eye(5);
M(5, 5) = 0;
M = @(t,y) M;
opts = odeset('Mass', M, 'Jacobian', J);
y0 = [1; 1; 0; -1; 0];
[t,y] = ode23t(f, [0 t(end)], y0, opts);

% Plot of the ode23t solution
plot(t, y(:, 1), t, y(:, 2), t, y(:, 3), t, y(:, 4), t, y(:, 5));
legend('x1', 'x2', 'x3', 'x4', 'x5');
print -dpdf firstDAE